module Points where
 
import Graphics.Rendering.OpenGL

points n = callpoints (0,0,0,0) ++ pointsax n

pointsax :: Int -> [(GLfloat,GLfloat,GLfloat,GLfloat)]
pointsax 0 = callpoints (0,0,0,0) -- ++ concat(map callpoints (callpoints (0,0,0,1))) 
pointsax 1 = callpoints (0,0,0,1)
pointsax n = concat (map callpoints (pointsax (n-1)))

callpoints :: (GLfloat,GLfloat,GLfloat,GLfloat) -> [(GLfloat,GLfloat,GLfloat,GLfloat)]
callpoints (x,y,z,0)   = 	[(0,0,0,1)]
callpoints (x,y,z,l)  =    [(x+  w,y+    w,  -w+z, s),
							(x+   w,y+   w,   w+z, s),
							(x   -w,y+   w,   w+z, s),
							(x   -w,y+   w,  -w+z, s),
							(x   -w,y - w ,  w+z, s),
							(x+   w, y-w,  -w+z, s),
							(x+   w, y -w,   w+z, s),
							(x   -w,  y-w,  -w+z, s),
							(x+ w*p,  y+ 0,-w/p+z, s),
							(x+ w*p,  y+ 0, w/p+z, s),
							(x -w*p,  y+ 0,-w/p+z, s),
							(x -w*p,  y+ 0, w/p+z, s),
							(x+0   ,y+ w/p ,-w*p+z, s),
							(x+0,   y-w/p,-w*p+z, s),
							(x+0,   y-w/p, w*p+z, s),
							(x+0,    y+w/p,w*p+z, s),
							(x+w/p, y-w*p,  0+z, s),
							(x-w/p,y-w*p,  0+z, s),
							(x-w/p, y+w*p,  0+z, s),
							(x+w/p,  y+w*p,  0+z, s)]
					where 
						w = l - s
						p = (1+(sqrt 5)) /2
						s = 5/20*l
